package com.link.core.webservice;

import com.link.core.basic.service.BasicServiceException;
import javax.xml.ws.soap.SOAPFaultException;
import org.apache.logging.log4j.LogManager;
import org.apache.logging.log4j.Logger;
import org.aspectj.lang.ProceedingJoinPoint;

public class SiebelWebServiceInterceptor {
   private static final Logger logger = LogManager.getLogger(SiebelWebServiceInterceptor.class);
   public final int RETRYTIMES = 2;

   public Object invokeWS(ProceedingJoinPoint pjp) throws Throwable {
      Object result = null;
      Long startTime = 0L;
      int times = 0;

      while(times < 2) {
         try {
            startTime = System.currentTimeMillis();
            if (times > 0) {
               logger.warn("Webservice 重连" + times + "次");
            }

            result = pjp.proceed();
            logger.debug("Intercep Method: {}", pjp.toString());
            break;
         } catch (SOAPFaultException var6) {
            if (!var6.getMessage().contains("10944642") && !var6.getMessage().contains("11338608") && !var6.getMessage().contains("10944657") && !var6.getMessage().contains("会话") && !var6.getMessage().contains("Session")) {
               if (!var6.getMessage().contains("10879185") && !var6.getMessage().contains("7668281")) {
                  logger.error("调用webservice错误", var6);
                  throw var6;
               }

               throw new BasicServiceException("HAND_SYSTEM_CODE");
            }

            logger.warn("Webservice session过期", var6);
            ++times;
         } catch (Exception var7) {
            Exception e = var7;
            logger.error("调用webservice错误", e);
            throw e;
         }
      }

      if (times >= 2) {
         throw new BasicServiceException("Web Service 连接超时,请稍后重试！");
      } else {
         return result;
      }
   }
}
